7b00cc3da1058a9c201b9f153d2882abbc820c90
[charm.git] / build
1 #!/bin/sh
2
3 # Silly shorthand, used for source reorganization
4 src="src/arch"
5
6 more=0
7
8 syntax() {
9   echo ''
10   echo 'Usage: build <target> <version> <options> [charmc-options ...]'
11   echo ''
12   echo '<targets>: converse charm++ LIBS AMPI FEM bigemulator pose jade msa'
13   echo '<targets>: doc ps-doc pdf-doc html-doc'
14   if test $more = 1
15   then
16   echo ''
17   echo '  charm++         compile Charm++ core only'
18   echo '  AMPI            compile Adaptive MPI on top of Charm++'
19   echo '  FEM             compile FEM framework'
20   echo '  LIBS            compile additional parallel libraries with Charm++ core'
21   echo '  bigemulator     build additional BigSim libraries'
22   echo '  pose            build POSE parallel discrete event simulator'
23   echo '  jade            build Jade compiler (auto-builds charm++, msa)'
24   echo '  msa             build Multiphase Shared Arrays(MSA) library'
25   echo '  Tau             build the TAU tracing library for generating TAU performance data' 
26   echo '  ChaNGa          compile Charm++ core and necessary libraries for ChaNGa'
27   echo ''
28   fi
29   echo '<versions>: ' 
30   ( cd $src ; ls -1 | egrep -v '(^CVS)|(^shmem$)|(^mpi$)|(^sim$)|(^net$)|(^multicore$)|(^elan$)|(^util$)|(^common$)|(^uth$)|(^conv-mach-fix.sh$)|(^win32$)|(^win64$)|(^paragon$)|(^vmi$)|(^lapi$)|(^cell$)|(^template$)|(^cuda$)' | pr -3 -t )
31   echo ''
32   echo '<options>: compiler and platform specific options'
33   echo 'cc cc64 cxx kcc pgcc acc icc ecc gcc3 gcc4 mpcc pathscale'
34   echo 'help smp gm tcp vmi scyld clustermatic bigemulator ooc syncft mlogft papi'
35   echo 'pthreads lam'
36   echo '--incdir --libdir --basedir --no-build-shared --destination --suffix -j'
37   if test $more = 1
38   then
39   echo ''
40   echo 'For platform specific options, use help option:'
41   echo '  help            platform specific help, e.g. ./build charm++ net-linux help'
42   echo ''
43   echo 'Choose a compiler (only one option is allowed from this section):'
44   echo '  cc, cc64        For Sun WorkShop C++ 32/64 bit compilers'
45   echo '  cxx             DIGITAL C++ compiler (DEC Alpha)'
46   echo '  kcc             KAI C++ compiler'
47   echo "  pgcc            Portland Group's C++ compiler"
48   echo '  acc             HP aCC compiler'
49   echo '  icc             Intel C/C++ compiler for Linux IA32'
50   echo '  ecc             Intel C/C++ compiler for Linux IA64'
51   echo '  gcc3            use gcc3 - GNU GCC/G++ version 3'
52   echo '  gcc4            use gcc4 - GNU GCC/G++ version 4 (only mpi-crayxt3)'
53   echo '  mpcc            SUN Solaris C++ compiler for MPI'
54   echo '  pathscale       use pathscale compiler suite'
55   echo ''
56   echo 'Choose a fortran compile (only one option is allowed from this section):'
57   echo '  g95             G95 at http://ww.g95.org'
58   echo '  absoft          Absoft fortran compiler'
59   echo "  pgf90           Portland Group\'s Fortran compiler"
60   echo '  ifc             Intel Fortran compiler (older versions)'
61   echo '  ifort           Intel Fortran compiler (newer versions)'
62   echo ''
63   echo 'Platform specific options (choose multiple if apply):'
64   echo '  lam             Use LAM MPI'
65   echo '  smp             support for SMP, multithreaded charm on each node'
66   echo '  mpt             use SGI Message Passing Toolkit (only for mpi version)'
67   echo '  gm              use Myrinet for communication'
68   echo '  tcp             use TCP sockets for communication (only for net version)'
69   echo '  ibverbs         use the Infiniband OpenIB layer for communication (only for net-linux-amd64 currently)'
70   echo "  vmi             use NCSA's VMI for communication (only for mpi version)"
71   echo '  scyld           compile for Scyld Beowulf cluster based on bproc'
72   echo '  clustermatic    compile for Clustermatic (support version 3 and 4) '
73   echo '  pthreads        compile with pthreads Converse threads'
74   echo ''
75   echo 'Advanced options:'
76   echo '  bigemulator     compile for BigSim simulator'
77   echo '  ooc             compile with out of core support'
78   echo '  syncft          compile with Charm++ fault tolerance support'
79   echo '  mlogft          compile with Charm++ message logging fault tolerance support'
80   echo '  papi            compile with PAPI performance counter support (if any)'
81   echo ''
82   echo "Charm++ dynamic libraries:"
83   echo "  --build-shared     build Charm++ dynamic libraries (.so) (default)"
84   echo "  --no-build-shared  don't build Charm++'s shared libraries"
85   echo ''
86   echo 'Miscellaneous options:'
87   echo '  --incdir=DIR       specify additional include path for compiler'
88   echo '  --libdir=DIR       specify additional lib path for compiler'
89   echo '  --basedir=DIR      shortcut for the above two - DIR/include and DIR/lib'
90   echo '  -j[N]              parallel make, N is the number of paralle make jobs'
91   echo "  --with-romio       build AMPI with ROMIO library"
92   echo "  --destination=DIR  build Charm++ inside DIR, by default the destination is <version>"
93   echo "  --suffix=DIR       append DIR to the destination directory of the Charm++ build"
94   echo "  --tau-makefile=FILE Specify which TAU stub makefile to use"
95   fi
96   echo ''
97   echo '<charmc-options>: normal compiler options e.g. -g -O -save -verbose'
98   if test $more = 1
99   then
100   echo ''
101   echo 'Examples:'
102   echo "1. display all supported options for net-linux using 'help':"
103   echo '  ./build charm++ net-linux help'
104   echo '2. compile Charm++ on Linux with optimizations:'
105   echo '  ./build charm++ net-linux -O -DCMK_OPTIMIZE'
106   echo '3. compile Charm++ for Linux clustermatic Beowulf cluster with Intel compiler:'
107   echo '  ./build charm++ net-linux clustermatic icc -O'
108   echo '4. compile Charm++ for IA64 Linux cluster with MPICH-GM:'
109   echo '  ./build charm++ mpi-linux-ia64 gm -O'
110   echo '5. compile Charm++ for Windows with VC++ (Cygwin required):'
111   echo '  ./build charm++ net-win32 -O'
112   echo '6. compile on IBM SP with MPI using parallel gmake, 4 jobs simultaneously:'
113   echo '  MAKE=gmake  ./build charm++ mpi-sp -j4 -O            # sh'
114   echo '  setenv MAKE gmake;  ./build charm++ mpi-sp -j4 -O    # csh'
115   echo '7. compile Charm++ with MPI that is installed at /usr/local/mpich:'
116   echo '  ./build charm++ mpi-linux --incdir /usr/local/mpich/include --libdir /usr/local/mpich/lib -O'
117   echo '   or in short,'
118   echo '  ./build charm++ mpi-linux --basedir /usr/local/mpich -O'
119   echo '  ./build Tau --tau-makefile=/usr/local/packages/TAU/x86_64/lib/Makefile.tau-mpi'
120   echo ''
121   echo 'Note: This script:'
122   echo ' 1. Creates directories <destination> and <destination>/tmp'
123   echo ' 2. Copies src/scripts/Makefile into <destination>/tmp'
124   echo ' 3. Does a "make basics" in <destination>/tmp.'
125   echo ' 3. Does a "make -jN <target> <version> OPTS=<charmc-options>" in <destination>/tmp.'
126   echo "That's all build does.  The rest is handled by the Makefile."
127   echo ''
128   echo 'Thank you for using Charm++, please send questions or comments to '
129   echo 'Parallel Programming Lab at University of Illinois at Urbana-Champaign'
130   echo '(email: charm@cs.uiuc.edu).'
131
132   else
133   echo ''
134   echo "To get more detailed help, run ./build --help"
135   fi
136 }
137
138 printOption() {
139   for prefix in cc conv-mach
140   do
141     str="Supported compilers:"
142     [ "$prefix" = "conv-mach" ] && str="Supported options:"
143     opts=""
144     for dir in $OPT_DIRS
145     do
146 #         echo "Checking for $prefix in $dir"
147           files=`cd $dir; ls $prefix-*.h 2>/dev/null`
148           opts="$opts "`echo $files | sed 's/'$prefix'-\([^.]*\).h/\1/g'`
149     done 
150     tmp=.tmp.$$
151     rm -f $tmp; touch $tmp
152     for o in $opts
153     do
154       echo $o >> $tmp
155     done
156     opts=`sort $tmp | uniq`
157     rm -f $tmp
158     echo $str $opts
159   done
160   exit 1
161 }
162
163 CheckDir() {
164   for d in $*
165   do
166     if test ! -d $d
167     then
168       echo Error: cannot find $d!
169       exit 1
170     fi
171   done
172 }
173
174 TestIfCompiler() {
175   for dir in $OPT_DIRS
176   do
177     [ -f $dir/cc-$1.sh ] && return 1
178   done  
179   return 0
180 }
181
182 TestIfOption() {
183   for dir in $OPT_DIRS
184   do
185     [ -f $dir/conv-mach-$1.h ] && return 1 
186   done
187   
188   echo "Error> option: $1 is not supported in this version!"; 
189   printOption
190 }
191
192
193 # start
194
195 MAKEOPTS=""
196 OPTS=""
197 BOPTS=""
198 MORE=""
199 COMPILER=""
200 BASEDIR=
201 LIBDIR=
202 INCDIR=
203 ARCH=
204 BUILD_SHARED=
205 WITH_ROMIO=
206 BUILD_EMULATOR=0
207 DESTINATION=""
208 DESTINATION_SUFFIX=""
209 TAU_MAKEFILE=""
210
211 [ "$1" = '--help' -o "$1" = '-h' ] && more=1 && syntax | more && exit 1
212 [ $# -lt 2 ] && ./smart-build.pl && exit 1
213 PROGRAM=$1
214 shift
215 VERSION=$1; BASEVERSION=$1; 
216 if test -f $src/$BASEVERSION/vdir_link
217 then
218   BASEVERSION=`cat $src/$BASEVERSION/vdir_link`
219 fi
220 ARCH=`echo $1 | sed -e 's@-.*@@'`
221 shift
222
223 #echo $src
224 #echo $BASEVERSION
225 #echo $ARCH
226
227 OPT_DIRS="$src/$BASEVERSION $src/$ARCH $src/common"
228
229 while [ ! $# -eq 0 ]
230 do
231   case "$1" in
232     "--basedir")
233                 shift; 
234                 for dir in $1
235                 do
236                   CheckDir $dir/include $dir/lib
237                   LIBDIR="$LIBDIR -L$dir/lib";
238                   INCDIR="$INCDIR -I$dir/include"
239                 done
240                 shift
241                 ;;
242     --basedir=*)
243                 basedir=`echo $1 | awk -F= '{print $2}'`
244                 for dir in $basedir
245                 do
246                   CheckDir $dir/include $dir/lib
247                   LIBDIR="$LIBDIR -L$dir/lib";
248                   INCDIR="$INCDIR -I$dir/include"
249                 done
250                 shift
251                 ;;
252     "--libdir")
253                 shift; CheckDir $1
254                 for dir in $1
255                 do
256                   LIBDIR="$LIBDIR -L$dir"; 
257                 done
258                 shift
259                 ;;
260     --libdir=*)
261                 libdir=`echo $1 | awk -F= '{print $2}'`
262                 CheckDir $libdir
263                 for dir in $libdir
264                 do
265                   LIBDIR="$LIBDIR -L$dir"; 
266                 done
267                 shift
268                 ;;
269     "--incdir")
270                 shift; CheckDir $1
271                 for dir in $1
272                 do
273                   INCDIR="$INCDIR -I$dir"; 
274                 done
275                 shift
276                 ;;
277     --incdir=*)
278                 incdir=`echo $1 | awk -F= '{print $2}'`
279                 CheckDir $incdir
280                 for dir in $incdir
281                 do
282                   INCDIR="$INCDIR -I$dir"; 
283                 done
284                 shift
285                 ;;
286     --no-build-shared|-nobs|--no-shared)
287                 BUILD_SHARED="-nobs"; shift
288                 ;;
289     --with-romio)
290                 WITH_ROMIO="true"; shift
291                 ;;
292     --build-shared|-bs)
293                 # obsolete, do nothing
294                 shift
295                 ;;
296     --destination)
297                 shift
298                 DESTINATION="$1"
299                 shift
300                 ;;
301     --destination=*)
302                 DESTINATION="`echo $1 | awk -F= '{print $2}'`"
303                 shift
304                 ;;
305     --suffix)
306                 shift
307                 DESTINATION_SUFFIX="$1"
308                 shift
309                 ;;
310     --suffix=*)
311                 DESTINATION_SUFFIX="`echo $1 | awk -F= '{print $2}'`"
312                 shift
313                 ;;
314     --tau-makefile)
315                 TAU_MAKEFILE=$1
316                 shift
317                 ;;
318     --tau-makefile=*)
319                 TAU_MAKEFILE=`echo $1 | awk -F= '{print $2}'`
320                 shift
321                 ;;
322     -j*)
323                 PMAKENUM=`echo $1 | awk -Fj '{print $2}'`
324                 MAKEOPTS="$MAKEOPTS -j $PMAKENUM"
325                 shift;
326                 ;;
327     -*) 
328 # We hit a real compiler option (like -g, or -Dfoo),
329 # so just copy over all remaining options
330           while [ ! $# -eq 0 ]
331           do
332             OPTS="$OPTS $1"; shift
333           done
334           ;;
335     "help")
336         printOption
337         ;;
338     *)
339 # This has to be a build-time option (like "smp", "gcc3", or "kcc")
340         TestIfCompiler $1
341         if [ $? -eq 1 ] 
342         then
343 # It specifies a compiler:
344           if [ ! -z "$COMPILER" ] 
345           then
346               echo "Error> Tried to specify two compilers: $COMPILER and $1"
347               printOption
348           fi
349           COMPILER=$1
350         else
351 # It specifies some other option:
352           TestIfOption $1
353           BOPTS="$BOPTS $1"
354           [ $1 =  "bigemulator" ] && BUILD_EMULATOR=1
355         fi
356         shift
357         ;;
358   esac
359 done
360
361 [ "x$VERSION" = "x" ] && syntax && exit 1
362
363 if [ -z "$MAKE" ] 
364 then
365   # prefer gmake
366   MAKE=`which gmake 2>/dev/null`
367   [ -z "$MAKE" -o ! -x "$MAKE" ] && MAKE='make'
368 fi
369
370 if [ ! -f $src/$BASEVERSION/conv-mach.h ] 
371 then
372   if [ "x_$BASEVERSION" = "x_net-rs6k" ]
373   then
374     echo "Error> build net-aix-ppc instead of net-rs6k!" 
375   else
376     echo "Error> build can not find arch: $BASEVERSION!" 
377   fi
378   exit 1
379 fi
380
381 #generate VERSION name combining all the build-time options.
382 if [ -n "$BOPTS" -o -n "$COMPILER" ]
383 then
384   echo "Selected Compiler: $COMPILER"
385   echo "Selected Options: $BOPTS"
386   SORTED=`echo $BOPTS | awk  '{ for (i = 1; i <= NF; ++i) print $i }' | sort`
387   BOPTS_WITHCOMPILER=`echo $SORTED $COMPILER`
388   for i in $BOPTS_WITHCOMPILER
389   do
390     VERSION=$VERSION-$i
391   done
392 fi
393
394 #echo "|$DESTINATION|$DESTINATION_SUFFIX|"
395
396 if [ -z "$DESTINATION" ]
397 then
398   DESTINATION="$VERSION"
399 fi
400
401 if [ -n "$DESTINATION_SUFFIX" ]
402 then
403   DESTINATION="$DESTINATION-$DESTINATION_SUFFIX"
404 fi
405
406 [ -d $DESTINATION ] || echo "Creating dir: $DESTINATION" 
407 [ -d $DESTINATION ] || mkdir $DESTINATION
408 [ -d $DESTINATION/tmp ] || echo "Creating dir: $DESTINATION/tmp" 
409 [ -d $DESTINATION/tmp ] || mkdir $DESTINATION/tmp
410
411 echo "Copying src/scripts/Makefile to $DESTINATION/tmp"
412 rm -f $DESTINATION/tmp/Makefile
413 rm -f $DESTINATION/tmp/Make.depends
414 rm -f $DESTINATION/tmp/Make.lb
415 rm -f $DESTINATION/tmp/Make.machine
416
417
418 # Create the bin, lib, include, etc. links:
419 WINNAME=`echo $VERSION | awk -F- '{print $2}'`
420 if [ "x_$WINNAME" = "x_win32" -o "x_$WINNAME" = "x_win64" ]
421 then
422 #Win32/64 version needs special compilers and *copied* (not linked)
423 # source files.
424         echo "Copying compilers for $WINNAME into cygwin /bin directory"
425         cp -f $src/$WINNAME/unix2nt* /bin
426         cp $src/win32/system_ln $DESTINATION/tmp
427         cp $src/win32/unistd.h $DESTINATION/tmp
428         echo "Compiling createlink.cpp ..."
429         (cd $src/win32; unix2nt_cc  -c createlink.cpp -o createlink.o -D_WIN32_WINNT=0x0500; unix2nt_cc createlink.o)
430         if test ! -x $src/win32/createlink.exe
431         then
432                 echo "VC++ is not properly installed!"
433                 exit 1
434         fi
435         echo "Copying $src/win32/createlink.exe to /bin directory"
436         cp $src/win32/createlink.exe /bin
437         chmod +x $DESTINATION/tmp/system_ln
438 else
439         cat > $DESTINATION/tmp/system_ln <<EOF
440 #!/bin/sh
441 ln -f -s \$@
442 EOF
443   chmod +x $DESTINATION/tmp/system_ln
444   for newdir in `echo bin lib lib_so include tmp`
445   do
446     echo "Soft-linking over $newdir"
447     if [ -r $newdir ]
448     then
449       rm -fr $newdir || exit 1
450     fi
451     $DESTINATION/tmp/system_ln $DESTINATION/$newdir $newdir
452   done
453   rm -f VERSION
454   $DESTINATION/tmp/system_ln $DESTINATION/include/VERSION VERSION
455 fi
456
457 $DESTINATION/tmp/system_ln "../../src/scripts/Make.depends" $DESTINATION/tmp/Make.depends
458 $DESTINATION/tmp/system_ln "../../src/ck-ldb/Make.lb" $DESTINATION/tmp/Make.lb
459 $DESTINATION/tmp/system_ln "../../src/scripts/Makefile" $DESTINATION/tmp/Makefile
460 $DESTINATION/tmp/system_ln "../../src/scripts/Make.tau" $DESTINATION/tmp/Make.tau
461 touch $DESTINATION/tmp/Makefile.machine
462
463 ConvUsr="$DESTINATION/tmp/conv-mach-pre.sh"
464 echo "Generating $ConvUsr"
465 echo > $ConvUsr
466 if test -n "$LIBDIR" 
467 then
468   echo 'USER_OPTS_LD="$USER_OPTS_LD '$LIBDIR'"' >> $ConvUsr
469   echo 'USER_OPTS_LDXX="$USER_OPTS_LDXX '$LIBDIR'"' >> $ConvUsr
470 fi
471 if test -n "$INCDIR" 
472 then
473   echo 'USER_OPTS_CC="$USER_OPTS_CC '$INCDIR'"' >> $ConvUsr
474   echo 'USER_OPTS_CXX="$USER_OPTS_CXX '$INCDIR'"' >> $ConvUsr
475 fi
476 chmod +x $ConvUsr
477
478 # Create conv-mach-opt headers with special build-time options
479 ConvHeader="$DESTINATION/tmp/conv-mach-opt.h"
480 ConvSh="$DESTINATION/tmp/conv-mach-opt.sh"
481 if [ ! -f $ConvSh -o ! -f $ConvHeader ]
482 then
483   echo "Generating $ConvHeader, conv-mach-opt.sh"
484   echo '/* Build-time options header, automatically generated by charm/build*/'> $ConvHeader
485   echo '# Built-time options header, automatically generated by charm/build'> $ConvSh
486   echo '[ -z "$CHARMINC" ] && CHARMINC="."' >> $ConvSh
487 fi
488 if test -n "$COMPILER"
489 then
490       i="$COMPILER"
491       echo '#include "'cc-$i.h'"' >> $ConvHeader
492       echo '. $CHARMINC/'"cc-$i.sh" >> $ConvSh
493 fi
494 if test -n "$BOPTS"
495 then
496     for i in $BOPTS
497     do
498       echo '#include "'conv-mach-$i.h'"' >> $ConvHeader
499       echo '. $CHARMINC/'"conv-mach-$i.sh" >> $ConvSh
500     done
501 fi
502
503 if test  -n "$BUILD_SHARED" 
504 then
505     echo "CMK_NO_BUILD_SHARED=true" >> $ConvSh
506 fi
507
508 if test  -n "$WITH_ROMIO" 
509 then
510     echo "CMK_AMPI_WITH_ROMIO=\"true\"" >> $ConvSh
511 fi
512
513
514 # build with Tau
515 WITH_TAU=0
516 if [ "$PROGRAM" = "Tau" ]
517 then
518         echo "TAU>>>> makefile config option: $TAU_MAKEFILE"
519         if [ -n "$TAU_MAKEFILE" -a -f $TAU_MAKEFILE ]
520         then
521           #Setting up TAU trace library:
522           echo "TAU>>>> configuring with this TAU makefile: $TAU_MAKEFILE"
523
524           WITH_TAU=1
525         else
526           echo "TAU>>>> ERROR could not find Makefile: $TAU_MAKEFILE, ignored"
527           TAU_MAKEFILE=""
528         fi
529 fi
530 [ -z "$TAU_MAKEFILE" ] && TAU_MAKEFILE="Make.tau"
531 SED_CHARMC="s@TAU_MAKEFILE=\(.*\)@TAU_MAKEFILE=$TAU_MAKEFILE@"
532
533 sed -e $SED_CHARMC src/scripts/Makefile > .Makefile.$$ && cp .Makefile.$$ src/scripts/Makefile && rm -f  .Makefile.$$
534 sed -e $SED_CHARMC src/scripts/charmc > .charmc.$$ && cp .charmc.$$ src/scripts/charmc && rm -f .charmc.$$
535
536 if test $WITH_TAU -eq 1
537 then
538     echo "#define CMK_WITH_TAU               1" >> $ConvHeader
539     echo "#define pthread_create             tau_pthread_create" >> $ConvHeader
540     echo "#define pthread_exit               tau_pthread_exit" >> $ConvHeader
541
542     echo "CMK_WITH_TAU=\"true\"" >> $ConvSh
543 fi
544
545
546 echo $BASEVERSION > $DESTINATION/tmp/.vdir
547 echo $VERSION | sed -e 's@-.*@@' > $DESTINATION/tmp/.gdir
548
549 if test $BUILD_EMULATOR = 1
550 then
551   PROGRAM="$PROGRAM bigsim"
552 fi
553
554 printError()
555 {
556         echo "-------------------------------------------------"
557         echo "Charm++ NOT BUILT. Either cd into $DESTINATION/tmp and try"
558         echo "to resolve the problems yourself, visit"
559         echo "    http://charm.cs.uiuc.edu/"
560         echo "for more information. Otherwise, email the developers at charm@cs.uiuc.edu"
561         exit $MAKEEXIT
562 }
563
564 echo "Performing '$MAKE $MAKEOPTS $PROGRAM OPTS="$OPTS"' in $VERSION/tmp"
565 cd $DESTINATION/tmp 
566 $MAKE $MAKEOPTS basics OPTS="$OPTS $BUILD_SHARED"
567 MAKEEXIT=$?
568 [ $MAKEEXIT -ne 0 ] && printError
569
570 $MAKE $MAKEOPTS $PROGRAM OPTS="$OPTS $BUILD_SHARED"
571 MAKEEXIT=$?
572 if [ $MAKEEXIT -eq 0 ]
573 then
574         echo "-------------------------------------------------"
575         echo "$PROGRAM built successfully."
576         echo "Next, try out a sample program like" \
577              "tests/charm++/simplearrayhello"
578 else
579         printError
580 fi